/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.162 Revision 1.258
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.162 2006/03/03 21:54:52 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.258 2011/08/18 14:58:57 vapier Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Maintainer: kernel-misc@gentoo.org
9# 10#
10# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
11 12
12# added functionality: 13# added functionality:
13# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
21# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
22# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
23# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
24# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
25# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
26# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
27# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
28# the patchset version for 31# the patchset version for
29# and not use it as a true package revision 32# and not use it as a true package revision
30# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
31# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
32# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
33# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
34# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
35# 39#
36# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
37# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
38# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any 42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
39# combination of "base" and "extras" 43# combination of "base" and "extras"
40# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply. 44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
41# A value of "5" would apply genpatches-2.6.12-5 to 45# A value of "5" would apply genpatches-2.6.12-5 to
42# my-sources-2.6.12.ebuild 46# my-sources-2.6.12.ebuild
43 47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49# code. If empty, will be set to "1" if deblobbing is
50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist
54# code.
55# K_LONGTERM - If set, the eclass will search for the kernel source
56# in the long term directories on the upstream servers
57# as the location has been changed by upstream
44# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 58# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
45# can be supported by the headers ebuild 59# can be supported by the headers ebuild
46 60
47# UNIPATCH_LIST - space delimetered list of patches to be applied to the 61# UNIPATCH_LIST - space delimetered list of patches to be applied to the
48# kernel 62# kernel
53# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 67# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
54# the doc dir 68# the doc dir
55# UNIPATCH_STRICTORDER - if this is set places patches into directories of 69# UNIPATCH_STRICTORDER - if this is set places patches into directories of
56# order, so they are applied in the order passed 70# order, so they are applied in the order passed
57 71
58inherit toolchain-funcs versionator multilib 72inherit eutils toolchain-funcs versionator multilib
59EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst 73EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
60 74
61# Added by Daniel Ostrow <dostrow@gentoo.org> 75# Added by Daniel Ostrow <dostrow@gentoo.org>
62# This is an ugly hack to get around an issue with a 32-bit userland on ppc64. 76# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
63# I will remove it when I come up with something more reasonable. 77# I will remove it when I come up with something more reasonable.
64[[ ${PROFILE_ARCH} == 'ppc64' ]] && CHOST='powerpc64-unknown-linux-gnu' 78[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
65 79
66export CTARGET=${CTARGET:-${CHOST}} 80export CTARGET=${CTARGET:-${CHOST}}
67if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 81if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
68 export CTARGET=${CATEGORY/cross-} 82 export CTARGET=${CATEGORY/cross-}
69fi 83fi
70 84
71HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 85HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
86[[ -z ${LICENSE} ]] && \
72LICENSE="GPL-2" 87 LICENSE="GPL-2"
88
89# This is the latest KV_PATCH of the deblob tool available from the
90# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
91# for ALL kernel-2 consumer packages where deblob is available.
92[[ -z ${DEBLOB_MAX_VERSION} ]] && DEBLOB_MAX_VERSION=38
93
94# No need to run scanelf/strip on kernel sources/headers (bug #134453).
95RESTRICT="binchecks strip"
73 96
74# set LINUX_HOSTCFLAGS if not already set 97# set LINUX_HOSTCFLAGS if not already set
75[[ -z ${LINUX_HOSTCFLAGS} ]] && \ 98[[ -z ${LINUX_HOSTCFLAGS} ]] && \
76 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 99 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
100
101# debugging functions
102#==============================================================
103# this function exists only to help debug kernel-2.eclass
104# if you are adding new functionality in, put a call to it
105# at the start of src_unpack, or during SRC_URI/dep generation.
106debug-print-kernel2-variables() {
107 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
108 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
109 UNIPATCH_LIST S KERNEL_URI ; do
110 debug-print "${v}: ${!v}"
111 done
112}
77 113
78#Eclass functions only from here onwards ... 114#Eclass functions only from here onwards ...
79#============================================================== 115#==============================================================
80handle_genpatches() { 116handle_genpatches() {
81 local tarball 117 local tarball
82 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1 118 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
119
120 debug-print "Inside handle_genpatches"
121 local oldifs=${IFS}
122 export IFS="."
123 local OKV_ARRAY=( $OKV )
124 export IFS=${oldifs}
125
126 # for > 3.0 kernels, handle genpatches tarball name
127 # genpatches for 3.0 and 3.0.1 might be named
128 # genpatches-3.0-1.base.tar.bz2 and genpatches-3.0-2.base.tar.bz2
129 # respectively. Handle this.
83 130
84 for i in ${K_WANT_GENPATCHES} ; do 131 for i in ${K_WANT_GENPATCHES} ; do
132 if [[ ${KV_MAJOR} -ge 3 ]]; then
133 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
134 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.bz2"
135 else
136 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.bz2"
137 fi
138 else
85 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2" 139 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
140 fi
141 debug-print "genpatches tarball: $tarball"
86 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}" 142 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
87 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}" 143 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
88 done 144 done
89} 145}
90 146
91detect_version() { 147detect_version() {
92 # this function will detect and set 148 # this function will detect and set
113 OKV=${OKV/_rc/-rc} 169 OKV=${OKV/_rc/-rc}
114 OKV=${OKV/-r*} 170 OKV=${OKV/-r*}
115 OKV=${OKV/_p*} 171 OKV=${OKV/_p*}
116 172
117 KV_MAJOR=$(get_version_component_range 1 ${OKV}) 173 KV_MAJOR=$(get_version_component_range 1 ${OKV})
174 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
175 local oldifs=${IFS}
176 export IFS="."
177 local OKV_ARRAY=( $OKV )
178 export IFS=${oldifs}
179
180 # if KV_MAJOR >= 3, then we have no more KV_MINOR
181 #if [[ ${KV_MAJOR} -lt 3 ]]; then
182 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
118 KV_MINOR=$(get_version_component_range 2 ${OKV}) 183 KV_MINOR=$(get_version_component_range 2 ${OKV})
119 KV_PATCH=$(get_version_component_range 3 ${OKV}) 184 KV_PATCH=$(get_version_component_range 3 ${OKV})
120
121 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then 185 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
186 KV_EXTRA=$(get_version_component_range 4- ${OKV})
187 KV_EXTRA=${KV_EXTRA/[-_]*}
188 else
189 KV_PATCH=$(get_version_component_range 3- ${OKV})
190 fi
191 else
192 KV_PATCH=$(get_version_component_range 2 ${OKV})
122 KV_EXTRA=$(get_version_component_range 4- ${OKV}) 193 KV_EXTRA=$(get_version_component_range 3- ${OKV})
123 KV_EXTRA=${KV_EXTRA/[-_]*} 194 KV_EXTRA=${KV_EXTRA/[-_]*}
195 fi
196
197 debug-print "KV_EXTRA is ${KV_EXTRA}"
198
199 KV_PATCH=${KV_PATCH/[-_]*}
200
201 local v n=0 missing
202 #if [[ ${KV_MAJOR} -lt 3 ]]; then
203 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
204 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
205 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
206 done
124 else 207 else
125 KV_PATCH=$(get_version_component_range 3- ${OKV}) 208 for v in CKV OKV KV_{MAJOR,PATCH} ; do
209 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
210 done
211 fi
212
213 [[ $n -eq 1 ]] && \
214 eerror "Missing variables: ${missing}" && \
215 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
216 unset v n missing
217
218# if [[ ${KV_MAJOR} -ge 3 ]]; then
219 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
220 KV_PATCH_ARR=(${KV_PATCH//\./ })
221
222 # at this point 080811, Linus is putting 3.1 kernels in 3.0 directory
223 # revisit when 3.1 is released
224 if [[ ${KV_PATCH} -gt 0 ]]; then
225 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
226 else
227 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_PATCH_ARR}"
126 fi 228 fi
127 KV_PATCH=${KV_PATCH/[-_]*} 229 # KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_PATCH_ARR}"
128 230 [[ -n "${K_LONGTERM}" ]] &&
231 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
232 else
233 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
129 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 234 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
235 [[ -n "${K_LONGTERM}" ]] &&
236 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
237 fi
238
239 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
240
241 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
242 # handle vanilla-sources-3.x.y correctly
243 if [[ ${PN/-*} == "vanilla" && ${KV_PATCH} -gt 0 ]]; then
244 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.bz2"
245 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
246 fi
247 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.bz2"
248 else
249 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
250 fi
130 251
131 RELEASE=${CKV/${OKV}} 252 RELEASE=${CKV/${OKV}}
132 RELEASE=${RELEASE/_beta} 253 RELEASE=${RELEASE/_beta}
133 RELEASE=${RELEASE/_rc/-rc} 254 RELEASE=${RELEASE/_rc/-rc}
134 RELEASE=${RELEASE/_pre/-pre} 255 RELEASE=${RELEASE/_pre/-pre}
256 # We cannot trivally call kernel_is here, because it calls us to detect the
257 # version
135 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git} 258 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
259 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
136 RELEASETYPE=${RELEASE//[0-9]} 260 RELEASETYPE=${RELEASE//[0-9]}
137 261
138 # Now we know that RELEASE is the -rc/-git 262 # Now we know that RELEASE is the -rc/-git
139 # and RELEASETYPE is the same but with its numerics stripped 263 # and RELEASETYPE is the same but with its numerics stripped
140 # we can work on better sorting EXTRAVERSION. 264 # we can work on better sorting EXTRAVERSION.
141 # first of all, we add the release 265 # first of all, we add the release
142 EXTRAVERSION="${RELEASE}" 266 EXTRAVERSION="${RELEASE}"
267 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
143 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 268 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
144 269
270 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
271 if [[ -n "${K_NOUSEPR}" ]]; then
272 # Don't add anything based on PR to EXTRAVERSION
273 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
145 if [[ -n ${K_PREPATCHED} ]]; then 274 elif [[ -n ${K_PREPATCHED} ]]; then
275 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
146 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 276 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
147 elif [[ "${ETYPE}" = "sources" ]]; then 277 elif [[ "${ETYPE}" = "sources" ]]; then
278 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
148 # For some sources we want to use the PV in the extra version 279 # For some sources we want to use the PV in the extra version
149 # This is because upstream releases with a completely different 280 # This is because upstream releases with a completely different
150 # versioning scheme. 281 # versioning scheme.
151 case ${PN/-*} in 282 case ${PN/-*} in
152 wolk) K_USEPV=1;; 283 wolk) K_USEPV=1;;
153 vserver) K_USEPV=1;; 284 vserver) K_USEPV=1;;
154 esac 285 esac
155 286
156 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 287 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
157 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 288 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
158 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 289 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
159 fi 290 fi
291 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
160 292
161 # The only messing around which should actually effect this is for KV_EXTRA 293 # The only messing around which should actually effect this is for KV_EXTRA
162 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else 294 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
163 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION 295 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
296
164 if [[ -n ${KV_EXTRA} ]]; then 297 if [[ -n ${KV_EXTRA} ]]; then
298 if [[ -n ${KV_MINOR} ]]; then
165 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}" 299 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
166 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2 300 else
167 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2" 301 OKV="${KV_MAJOR}.${KV_PATCH}"
302 fi
303 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.bz2
304 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
168 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2" 305 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
169 fi 306 fi
170 307
171 # We need to set this using OKV, but we need to set it before we do any 308 # We need to set this using OKV, but we need to set it before we do any
172 # messing around with OKV based on RELEASETYPE 309 # messing around with OKV based on RELEASETYPE
180 # for example: 317 # for example:
181 # CKV="2.6.11_rc3_pre2" 318 # CKV="2.6.11_rc3_pre2"
182 # will pull: 319 # will pull:
183 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2 320 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
184 321
322 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
323
185 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 324 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
186 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 325 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
187 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 326 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.bz2
188 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 327 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
189 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 328 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
190 fi 329 fi
191 330
192 if [[ ${RELEASETYPE} == -git ]]; then 331 if [[ ${RELEASETYPE} == -git ]]; then
193 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 332 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.bz2
194 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 333 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
195 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 334 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
196 fi 335 fi
197 336
198 if [[ ${RELEASETYPE} == -rc-git ]]; then 337 if [[ ${RELEASETYPE} == -rc-git ]]; then
199 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 338 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
200 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 339 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
201 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 340 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
202 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 341 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
342
203 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 343 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
204 fi 344 fi
345 else
346 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
347 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
348 OKV="2.6.39"
349 else
350 KV_PATCH_ARR=(${KV_PATCH//\./ })
351 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
352 fi
353 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.bz2
354 ${KERNEL_BASE_URI}/testing/linux-${OKV}.tar.bz2"
355 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
356 fi
357
358 if [[ ${RELEASETYPE} == -git ]]; then
359 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.bz2
360 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
361 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
362 fi
363
364 if [[ ${RELEASETYPE} == -rc-git ]]; then
365 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
366 OKV="2.6.39"
367 else
368 KV_PATCH_ARR=(${KV_PATCH//\./ })
369 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
370 fi
371 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.bz2
372 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.bz2
373 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
374
375 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.bz2"
376 fi
377
378
379 fi
380
381
382 debug-print-kernel2-variables
205 383
206 handle_genpatches 384 handle_genpatches
207} 385}
208 386
209kernel_is() { 387kernel_is() {
388 # ALL of these should be set before we can safely continue this function.
389 # some of the sources have in the past had only one set.
390 local v n=0
391 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
210 [[ -z ${OKV} ]] && detect_version 392 [[ $n -eq 1 ]] && detect_version
393 unset v n
394
395 # Now we can continue
211 local operator test value x=0 y=0 z=0 396 local operator test value x=0 y=0 z=0
212 397
213 case ${1} in 398 case ${1} in
214 lt) operator="-lt"; shift;; 399 lt) operator="-lt"; shift;;
215 gt) operator="-gt"; shift;; 400 gt) operator="-gt"; shift;;
247} 432}
248 433
249# Capture the sources type and set DEPENDs 434# Capture the sources type and set DEPENDs
250if [[ ${ETYPE} == sources ]]; then 435if [[ ${ETYPE} == sources ]]; then
251 DEPEND="!build? ( sys-apps/sed 436 DEPEND="!build? ( sys-apps/sed
252 >=sys-devel/binutils-2.11.90.0.31 ) 437 >=sys-devel/binutils-2.11.90.0.31 )"
253 doc? ( app-text/docbook-sgml-utils
254 app-text/xmlto )"
255 RDEPEND="!build? ( >=sys-libs/ncurses-5.2 438 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
256 sys-devel/make ) 439 sys-devel/make )"
257 virtual/dev-manager" 440 PDEPEND="!build? ( virtual/dev-manager )"
258
259 PROVIDE="virtual/linux-sources"
260 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
261 441
262 SLOT="${PVR}" 442 SLOT="${PVR}"
263 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel" 443 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR:-$KV_PATCH} linux kernel"
264 IUSE="symlink build doc" 444 IUSE="symlink build"
445
446 # Bug #266157, deblob for libre support
447 if [[ -z ${K_PREDEBLOBBED} ]] ; then
448 # Bug #359865, force a call to detect_version if needed
449 kernel_is ge 2 6 27 && \
450 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
451 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
452 K_DEBLOB_AVAILABLE=1
453 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
454 IUSE="${IUSE} deblob"
455 # Reflect that kernels contain firmware blobs unless otherwise
456 # stripped
457 LICENSE="${LICENSE} !deblob? ( freedist )"
458
459 if [[ -n KV_MINOR ]]; then
460 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
461 else
462 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
463 fi
464
465 if [[ ${KV_MAJOR} -ge 3 ]]; then
466 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
467 fi
468
469 DEBLOB_A="deblob-${DEBLOB_PV}"
470 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
471 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
472 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
473 if ! has "${EAPI:-0}" 0 1 ; then
474 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
475 else
476 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
477 fi
478 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
479 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
480
481 KERNEL_URI="${KERNEL_URI}
482 deblob? (
483 ${DEBLOB_URI}
484 ${DEBLOB_CHECK_URI}
485 )"
486 else
487 # We have no way to deblob older kernels, so just mark them as
488 # tainted with non-libre materials.
489 LICENSE="${LICENSE} freedist"
490 fi
491 fi
492
265elif [[ ${ETYPE} == headers ]]; then 493elif [[ ${ETYPE} == headers ]]; then
266 DESCRIPTION="Linux system headers" 494 DESCRIPTION="Linux system headers"
267 IUSE="" 495
496 # Since we should NOT honour KBUILD_OUTPUT in headers
497 # lets unset it here.
498 unset KBUILD_OUTPUT
268 499
269 if [[ ${CTARGET} = ${CHOST} ]]; then 500 if [[ ${CTARGET} = ${CHOST} ]]; then
270 DEPEND="!virtual/os-headers"
271 PROVIDE="virtual/os-headers"
272 SLOT="0" 501 SLOT="0"
273 else 502 else
274 SLOT="${CTARGET}" 503 SLOT="${CTARGET}"
275 fi 504 fi
276else 505else
281# Cross-compile support functions 510# Cross-compile support functions
282#============================================================== 511#==============================================================
283kernel_header_destdir() { 512kernel_header_destdir() {
284 [[ ${CTARGET} == ${CHOST} ]] \ 513 [[ ${CTARGET} == ${CHOST} ]] \
285 && echo /usr/include \ 514 && echo /usr/include \
286 || echo /usr/${CTARGET}/include 515 || echo /usr/${CTARGET}/usr/include
287} 516}
288 517
289cross_pre_c_headers() { 518cross_pre_c_headers() {
290 [[ -z ${_E_CROSS_HEADERS_ONLY} ]] && return 1 519 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
291 [[ ${CHOST} == ${CTARGET} ]] && return 1
292 return 0
293} 520}
294 521
295env_setup_xmakeopts() { 522env_setup_xmakeopts() {
296 # Kernel ARCH != portage ARCH 523 # Kernel ARCH != portage ARCH
297 export KARCH=$(tc-arch-kernel) 524 export KARCH=$(tc-arch-kernel)
308} 535}
309 536
310# Unpack functions 537# Unpack functions
311#============================================================== 538#==============================================================
312unpack_2_4() { 539unpack_2_4() {
313 env_setup_xmakeopts
314
315 cd "${S}"
316 # this file is required for other things to build properly, 540 # this file is required for other things to build properly,
317 # so we autogenerate it 541 # so we autogenerate it
318 make -s mrproper ${xmakeopts} || die "make mrproper failed" 542 make -s mrproper ${xmakeopts} || die "make mrproper failed"
319 make -s symlinks ${xmakeopts} || die "make symlinks failed" 543 make -s symlinks ${xmakeopts} || die "make symlinks failed"
320 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 544 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
321 echo ">>> version.h compiled successfully." 545 echo ">>> version.h compiled successfully."
322} 546}
323 547
324unpack_2_6() { 548unpack_2_6() {
325 env_setup_xmakeopts
326
327 cd "${S}"
328
329 # since KBUILD_OUTPUT should only be used on the active kernel
330 # sources, we should unset it here.
331 [[ -n "${KBUILD_OUTPUT}" ]] && unset KBUILD_OUTPUT
332
333 # this file is required for other things to build properly, so we 549 # this file is required for other things to build properly, so we
334 # autogenerate it ... touch .config to keep version.h build from 550 # autogenerate it ... generate a .config to keep version.h build from
335 # spitting out an annoying warning 551 # spitting out an annoying warning
552 make -s mrproper ${xmakeopts} 2>/dev/null \
553 || die "make mrproper failed"
554
555 # quick fix for bug #132152 which triggers when it cannot include linux
556 # headers (ie, we have not installed it yet)
557 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
336 touch .config 558 touch .config
337 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 559 eerror "make defconfig failed."
338 make -s mrproper ${xmakeopts} || die "make mrproper failed" 560 eerror "assuming you dont have any headers installed yet and continuing"
339 rm -f .config 561 epause 5
562 fi
563
564 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
565 || die "make include/linux/version.h failed"
566 rm -f .config >/dev/null
340} 567}
341 568
342universal_unpack() { 569universal_unpack() {
570 debug-print "Inside universal_unpack"
571
572 local oldifs=${IFS}
573 export IFS="."
574 local OKV_ARRAY=( $OKV )
575 export IFS=${oldifs}
576
343 cd ${WORKDIR} 577 cd "${WORKDIR}"
578 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
579 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.bz2
580 else
344 unpack linux-${OKV}.tar.bz2 581 unpack linux-${OKV}.tar.bz2
582 fi
583
584 if [[ -d "linux" ]]; then
585 debug-print "Moving linux to linux-${KV_FULL}"
586 mv linux linux-${KV_FULL} \
587 || die "Unable to move source tree to ${KV_FULL}."
345 if [[ "${OKV}" != "${KV_FULL}" ]]; then 588 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
589 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
590 [[ "${ETYPE}" = "sources" ]]; then
591 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
592 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
593 || die "Unable to move source tree to ${KV_FULL}."
594 else
595 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
346 mv linux-${OKV} linux-${KV_FULL} \ 596 mv linux-${OKV} linux-${KV_FULL} \
597 || die "Unable to move source tree to ${KV_FULL}."
598 fi
599 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
600 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
347 || die "Unable to move source tree to ${KV_FULL}." 601 || die "Unable to move source tree to ${KV_FULL}."
348 fi 602 fi
349 cd "${S}" 603 cd "${S}"
350 604
351 # remove all backup files 605 # remove all backup files
352 find . -iname "*~" -exec rm {} \; 2> /dev/null 606 find . -iname "*~" -exec rm {} \; 2> /dev/null
353 607
354 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 608 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
355 use ppc && \ 609 # only do this for kernel < 2.6.27 since this file does not exist in later
610 # kernels
611 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
612 then
613 sed -i \
356 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 614 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
357 "${S}"/arch/ppc/Makefile 615 "${S}"/arch/ppc/Makefile
616 else
617 sed -i \
618 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
619 "${S}"/arch/powerpc/Makefile
620 fi
358} 621}
359 622
360unpack_set_extraversion() { 623unpack_set_extraversion() {
361 cd "${S}" 624 cd "${S}"
362 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 625 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
363 cd ${OLDPWD} 626 cd "${OLDPWD}"
364} 627}
365 628
366# Should be done after patches have been applied 629# Should be done after patches have been applied
367# Otherwise patches that modify the same area of Makefile will fail 630# Otherwise patches that modify the same area of Makefile will fail
368unpack_fix_install_path() { 631unpack_fix_install_path() {
369 cd "${S}" 632 cd "${S}"
370 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 633 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
371} 634}
372 635
373unpack_fix_docbook() {
374 if [[ -d ${S}/Documentation/DocBook ]]; then
375 cd "${S}"/Documentation/DocBook
376 sed -ie "s:db2:docbook2:g" Makefile
377 cd ${OLDPWD}
378 fi
379}
380
381# Compile Functions 636# Compile Functions
382#============================================================== 637#==============================================================
383compile_headers() { 638compile_headers() {
384 env_setup_xmakeopts 639 env_setup_xmakeopts
385
386 # Since KBUILD_OUTPUT shouldnt be used when compiling headers, lets unset it
387 # if it exists.
388 [[ -n ${KBUILD_OUTPUT} ]] && unset KBUILD_OUTPUT
389 640
390 # if we couldnt obtain HOSTCFLAGS from the Makefile, 641 # if we couldnt obtain HOSTCFLAGS from the Makefile,
391 # then set it to something sane 642 # then set it to something sane
392 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile) 643 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
393 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 644 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
395 if kernel_is 2 4; then 646 if kernel_is 2 4; then
396 yes "" | make oldconfig ${xmakeopts} 647 yes "" | make oldconfig ${xmakeopts}
397 echo ">>> make oldconfig complete" 648 echo ">>> make oldconfig complete"
398 make dep ${xmakeopts} 649 make dep ${xmakeopts}
399 elif kernel_is 2 6; then 650 elif kernel_is 2 6; then
651 # 2.6.18 introduces headers_install which means we dont need any
652 # of this crap anymore :D
653 kernel_is ge 2 6 18 && return 0
654
400 # autoconf.h isnt generated unless it already exists. plus, we have 655 # autoconf.h isnt generated unless it already exists. plus, we have
401 # no guarantee that any headers are installed on the system... 656 # no guarantee that any headers are installed on the system...
402 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 657 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
403 || touch include/linux/autoconf.h 658 || touch include/linux/autoconf.h
404 659
405 # if K_DEFCONFIG isn't set, force to "defconfig" 660 # if K_DEFCONFIG isn't set, force to "defconfig"
406 # needed by mips 661 # needed by mips
407 if [[ -z ${K_DEFCONFIG} ]]; then 662 if [[ -z ${K_DEFCONFIG} ]]; then
663 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
664 case ${CTARGET} in
665 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
666 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
667 *) K_DEFCONFIG="defconfig";;
668 esac
669 else
408 K_DEFCONFIG="defconfig" 670 K_DEFCONFIG="defconfig"
671 fi
409 fi 672 fi
410 673
411 # if there arent any installed headers, then there also isnt an asm 674 # if there arent any installed headers, then there also isnt an asm
412 # symlink in /usr/include/, and make defconfig will fail, so we have 675 # symlink in /usr/include/, and make defconfig will fail, so we have
413 # to force an include path with $S. 676 # to force an include path with $S.
414 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 677 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
415 ln -sf asm-${KARCH} "${S}"/include/asm 678 ln -sf asm-${KARCH} "${S}"/include/asm
416 cross_pre_c_headers && return 0 679 cross_pre_c_headers && return 0
417 680
418 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 681 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
682 if compile_headers_tweak_config ; then
683 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
684 fi
419 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 685 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
420 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 686 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
421 fi 687 fi
422} 688}
423 689
424compile_manpages() { 690compile_headers_tweak_config() {
425 einfo "Making manpages ..." 691 # some targets can be very very picky, so let's finesse the
426 env -u ARCH -u KBUILD_OUTPUT make mandocs 692 # .config based upon any info we may have
693 case ${CTARGET} in
694 sh*)
695 sed -i '/CONFIG_CPU_SH/d' .config
696 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
697 return 0;;
698 esac
699
700 # no changes, so lets do nothing
701 return 1
427} 702}
428 703
429# install functions 704# install functions
430#============================================================== 705#==============================================================
431install_universal() { 706install_universal() {
432 #fix silly permissions in tarball 707 #fix silly permissions in tarball
433 cd ${WORKDIR} 708 cd "${WORKDIR}"
434 chown -R root:root * 709 chown -R root:0 * >& /dev/null
435 chmod -R a+r-w+X,u+w * 710 chmod -R a+r-w+X,u+w *
436 cd ${OLDPWD} 711 cd ${OLDPWD}
437} 712}
438 713
439install_headers() { 714install_headers() {
440 local ddir=$(kernel_header_destdir) 715 local ddir=$(kernel_header_destdir)
441 716
442 cd "${S}" 717 # 2.6.18 introduces headers_install which means we dont need any
718 # of this crap anymore :D
719 if kernel_is ge 2 6 18 ; then
720 env_setup_xmakeopts
721 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
722
723 # let other packages install some of these headers
724 rm -rf "${D}"/${ddir}/sound #alsa-headers
725 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
726 return 0
727 fi
728
729 # Do not use "linux/*" as that can cause problems with very long
730 # $S values where the cmdline to cp is too long
731 pushd "${S}" >/dev/null
443 dodir ${ddir}/linux 732 dodir ${ddir}/linux
444 cp -ax "${S}"/include/linux/* ${D}/${ddir}/linux 733 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
445 rm -rf ${D}/${ddir}/linux/modules 734 rm -rf "${D}"/${ddir}/linux/modules
446 735
447 # Handle multilib headers and crap
448 local multi_dirs="" multi_defs=""
449 case $(tc-arch-kernel) in
450 sparc64)
451 multi_dirs="sparc sparc64"
452 multi_defs="!__arch64__ __arch64__"
453 ;;
454 x86_64)
455 multi_dirs="i386 x86_64"
456 multi_defs="__i386__ __x86_64__"
457 ;;
458 ppc64)
459 multi_dirs="ppc ppc64"
460 multi_defs="!__powerpc64__ __powerpc64__"
461 ;;
462 s390x)
463 multi_dirs="s390 s390x"
464 multi_defs="!__s390x__ __s390x__"
465 ;;
466 arm)
467 dodir ${ddir}/asm 736 dodir ${ddir}/asm
468 cp -ax "${S}"/include/asm/* "${D}"/${ddir}/asm 737 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
469 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
470 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
471 ;;
472 powerpc)
473 dodir ${ddir}/asm
474 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm
475 if [[ -e "${S}"/include/asm-ppc ]] ; then
476 dodir ${ddir}/asm-ppc
477 cp -ax "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
478 fi
479 ;;
480 *)
481 dodir ${ddir}/asm
482 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm
483 ;;
484 esac
485 if [[ -n ${multi_dirs} ]] ; then
486 local d ml_inc=""
487 for d in ${multi_dirs} ; do
488 dodir ${ddir}/asm-${d}
489 cp -ax "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
490 738
491 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
492 multi_defs=${multi_defs#* }
493 done
494 create_ml_includes ${ddir}/asm ${ml_inc}
495 fi
496
497 if kernel_is 2 6; then 739 if kernel_is 2 6 ; then
498 dodir ${ddir}/asm-generic 740 dodir ${ddir}/asm-generic
499 cp -ax "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic 741 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
500 fi 742 fi
501 743
502 # clean up 744 # clean up
503 find "${D}" -name '*.orig' -exec rm -f {} \; 745 find "${D}" -name '*.orig' -exec rm -f {} \;
504 746
505 cd ${OLDPWD} 747 popd >/dev/null
506} 748}
507 749
508install_sources() { 750install_sources() {
509 local doc docs file 751 local file
510 752
511 cd "${S}" 753 cd "${S}"
512 dodir /usr/src 754 dodir /usr/src
513 echo ">>> Copying sources ..." 755 echo ">>> Copying sources ..."
514 756
528 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 770 [[ -f ${FILESDIR}/../ChangeLog ]] && \
529 echo "Please check the ebuild ChangeLog for more details." \ 771 echo "Please check the ebuild ChangeLog for more details." \
530 > "${S}"/patches.txt 772 > "${S}"/patches.txt
531 fi 773 fi
532 774
533 if use doc ; then
534 install_manpages
535
536 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
537 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
538 [[ -n ${docs} ]] && dodoc ${docs}
539 fi
540
541 mv ${WORKDIR}/linux* ${D}/usr/src 775 mv ${WORKDIR}/linux* "${D}"/usr/src
542}
543
544install_manpages() {
545 kernel_is lt 2 5 && return
546
547 local myfiles="Documentation/DocBook/Makefile"
548 kernel_is lt 2 6 12 && myfiles="scripts/makeman ${myfiles}"
549
550 sed -ie "s#/usr/local/man#${D}/usr/share/man#g" ${myfiles}
551 ebegin "Installing manpages"
552 env -u ARCH make installmandocs
553 eend $?
554 sed -ie "s#${D}/usr/share/man#/usr/local/man#g" ${myfiles}
555} 776}
556 777
557# pkg_preinst functions 778# pkg_preinst functions
558#============================================================== 779#==============================================================
559preinst_headers() { 780preinst_headers() {
568 local MAKELINK=0 789 local MAKELINK=0
569 790
570 # if we have USE=symlink, then force K_SYMLINK=1 791 # if we have USE=symlink, then force K_SYMLINK=1
571 use symlink && K_SYMLINK=1 792 use symlink && K_SYMLINK=1
572 793
794 # if we're using a deblobbed kernel, it's not supported
795 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
796 use deblob && \
797 K_SECURITY_UNSUPPORTED=deblob
798
573 # if we are to forcably symlink, delete it if it already exists first. 799 # if we are to forcably symlink, delete it if it already exists first.
574 if [[ -n ${K_SYMLINK} ]]; then 800 if [[ ${K_SYMLINK} > 0 ]]; then
575 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 801 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
576 MAKELINK=1 802 MAKELINK=1
577 fi 803 fi
578 804
579 # if the link doesnt exist, lets create it 805 # if the link doesnt exist, lets create it
580 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 806 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
581 807
582 if [[ ${MAKELINK} == 1 ]]; then 808 if [[ ${MAKELINK} == 1 ]]; then
583 cd ${ROOT}usr/src 809 cd "${ROOT}"usr/src
584 ln -sf linux-${KV_FULL} linux 810 ln -sf linux-${KV_FULL} linux
585 cd ${OLDPWD} 811 cd ${OLDPWD}
586 fi 812 fi
587 813
588 # Don't forget to make directory for sysfs 814 # Don't forget to make directory for sysfs
589 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 815 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
590 816
591 echo 817 echo
592 einfo "After installing a new kernel of any version, it is important"
593 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
594 einfo "created (X.Y is the first 2 parts of your new kernel version)"
595 echo
596 einfo "For example, this kernel will require:"
597 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
598 echo
599 einfo "If you are upgrading from a previous kernel, you may be interested" 818 elog "If you are upgrading from a previous kernel, you may be interested"
600 einfo "in the following documents:" 819 elog "in the following document:"
601 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 820 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
602 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
603 if kernel_is ge 2 6 13; then
604 ewarn "As of 2.6.13 the support for devfs has been removed."
605 ewarn "You will be required to either manage a static /dev"
606 ewarn "or to ensure that udev is starting on boot."
607 fi
608 echo 821 echo
609 822
610 # if K_EXTRAEINFO is set then lets display it now 823 # if K_EXTRAEINFO is set then lets display it now
611 if [[ -n ${K_EXTRAEINFO} ]]; then 824 if [[ -n ${K_EXTRAEINFO} ]]; then
612 echo ${K_EXTRAEINFO} | fmt | 825 echo ${K_EXTRAEINFO} | fmt |
613 while read -s ELINE; do einfo "${ELINE}"; done 826 while read -s ELINE; do einfo "${ELINE}"; done
614 fi 827 fi
615 828
829 # if K_EXTRAELOG is set then lets display it now
830 if [[ -n ${K_EXTRAELOG} ]]; then
831 echo ${K_EXTRAELOG} | fmt |
832 while read -s ELINE; do elog "${ELINE}"; done
833 fi
834
616 # if K_EXTRAEWARN is set then lets display it now 835 # if K_EXTRAEWARN is set then lets display it now
617 if [[ -n ${K_EXTRAEWARN} ]]; then 836 if [[ -n ${K_EXTRAEWARN} ]]; then
618 echo ${K_EXTRAEWARN} | fmt | 837 echo ${K_EXTRAEWARN} | fmt |
619 while read -s ELINE; do ewarn "${ELINE}"; done 838 while read -s ELINE; do ewarn "${ELINE}"; done
620 fi 839 fi
621}
622 840
623postinst_headers() { 841 # optionally display security unsupported message
624 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 842 # Start with why
625 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 843 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
626 einfo "emerge glibc" 844 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
627 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 845 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
628 einfo "headers." 846 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
847 fi
848 # And now the general message.
849 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
850 ewarn "This means that it is likely to be vulnerable to recent security issues."
851 ewarn "For specific information on why this kernel is unsupported, please read:"
852 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
853 fi
854
855 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
856 KV_MAJOR=$(get_version_component_range 1 ${OKV})
857 KV_MINOR=$(get_version_component_range 2 ${OKV})
858 KV_PATCH=$(get_version_component_range 3 ${OKV})
859 if [[ "$(tc-arch)" = "sparc" ]]; then
860 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
861 then
862 echo
863 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
864 elog "you now need to do"
865 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
866 elog "instead of just"
867 elog " make"
868 elog "to compile the kernel. For more information please browse to"
869 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
870 echo
871 fi
872 fi
629} 873}
630 874
631# pkg_setup functions 875# pkg_setup functions
632#============================================================== 876#==============================================================
633setup_headers() { 877setup_headers() {
659 903
660 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 904 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
661 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 905 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
662 906
663 # We're gonna need it when doing patches with a predefined patchlevel 907 # We're gonna need it when doing patches with a predefined patchlevel
664 shopt -s extglob 908 eshopts_push -s extglob
665 909
666 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 910 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
667 # usage can be either via an env var or by params 911 # usage can be either via an env var or by params
668 # although due to the nature we pass this within this eclass 912 # although due to the nature we pass this within this eclass
669 # it shall be by param only. 913 # it shall be by param only.
670 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 914 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
671 UNIPATCH_LIST="${@}" 915 UNIPATCH_LIST="${@}"
672 916
673 #unpack any passed tarballs 917 #unpack any passed tarballs
674 for i in ${UNIPATCH_LIST}; do 918 for i in ${UNIPATCH_LIST}; do
675 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 919 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
676 extention=${i/*./}
677 extention=${extention/:*/}
678 case ${extention} in
679 tbz2) PIPE_CMD="tar -xvjf";;
680 bz2) PIPE_CMD="tar -xvjf";;
681 tgz) PIPE_CMD="tar -xvzf";;
682 gz) PIPE_CMD="tar -xvzf";;
683 *) eerror "Unrecognized tarball compression"
684 die "Unrecognized tarball compression";;
685 esac
686
687 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 920 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
688 unset z 921 unset z
689 STRICT_COUNT=$((10#${STRICT_COUNT} + 1)) 922 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
690 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 923 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
691 do z="${z}0"; 924 do z="${z}0";
692 done 925 done
693 PATCH_ORDER="${z}${STRICT_COUNT}" 926 PATCH_ORDER="${z}${STRICT_COUNT}"
694 927
695 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 928 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
696 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 929 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
930 unpack ${i##*/}
931 popd >/dev/null
697 else 932 else
698 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 933 pushd "${KPATCH_DIR}" >/dev/null
934 unpack ${i##*/}
935 popd >/dev/null
699 fi 936 fi
700 937
701 if [ $? == 0 ]; then
702 einfo "${i/*\//} unpacked"
703 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 938 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
704 else
705 eerror "Failed to unpack ${i/:*/}"
706 die "unable to unpack patch tarball"
707 fi
708 else 939 else
709 extention=${i/*./} 940 extention=${i/*./}
710 extention=${extention/:*/} 941 extention=${extention/:*/}
711 PIPE_CMD="" 942 PIPE_CMD=""
712 case ${extention} in 943 case ${extention} in
944 xz) PIPE_CMD="xz -dc";;
945 lzma) PIPE_CMD="lzma -dc";;
713 bz2) PIPE_CMD="bzip2 -dc";; 946 bz2) PIPE_CMD="bzip2 -dc";;
714 patch) PIPE_CMD="cat";; 947 patch) PIPE_CMD="cat";;
715 diff) PIPE_CMD="cat";; 948 diff) PIPE_CMD="cat";;
716 gz|Z|z) PIPE_CMD="gzip -dc";; 949 gz|Z|z) PIPE_CMD="gzip -dc";;
717 ZIP|zip) PIPE_CMD="unzip -p";; 950 ZIP|zip) PIPE_CMD="unzip -p";;
740 do z="${z}0"; 973 do z="${z}0";
741 done 974 done
742 PATCH_ORDER="${z}${STRICT_COUNT}" 975 PATCH_ORDER="${z}${STRICT_COUNT}"
743 976
744 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 977 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
745 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) 978 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
746 else 979 else
747 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) 980 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
748 fi 981 fi
749 fi 982 fi
750 fi 983 fi
751 done 984 done
752 985
754 x=${KPATCH_DIR} 987 x=${KPATCH_DIR}
755 KPATCH_DIR="" 988 KPATCH_DIR=""
756 for i in $(find ${x} -type d | sort -n); do 989 for i in $(find ${x} -type d | sort -n); do
757 KPATCH_DIR="${KPATCH_DIR} ${i}" 990 KPATCH_DIR="${KPATCH_DIR} ${i}"
758 done 991 done
992
993 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
994 # bug #272676
995 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
996 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
997 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
998 echo
999 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
1000 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
1001 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
1002 echo
1003 fi
1004 fi
759 1005
760 #so now lets get rid of the patchno's we want to exclude 1006 #so now lets get rid of the patchno's we want to exclude
761 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 1007 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
762 for i in ${UNIPATCH_DROP}; do 1008 for i in ${UNIPATCH_DROP}; do
763 ebegin "Excluding Patch #${i}" 1009 ebegin "Excluding Patch #${i}"
777 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 1023 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
778 1024
779 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 1025 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
780 while [ ${PATCH_DEPTH} -lt 5 ]; do 1026 while [ ${PATCH_DEPTH} -lt 5 ]; do
781 echo "Attempting Dry-run:" >> ${STDERR_T} 1027 echo "Attempting Dry-run:" >> ${STDERR_T}
782 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 1028 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
783 echo "=======================================================" >> ${STDERR_T} 1029 echo "=======================================================" >> ${STDERR_T}
784 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 1030 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
785 echo "Attempting patch:" > ${STDERR_T} 1031 echo "Attempting patch:" > ${STDERR_T}
786 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 1032 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
787 echo "=======================================================" >> ${STDERR_T} 1033 echo "=======================================================" >> ${STDERR_T}
788 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 1034 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
789 eend 0 1035 eend 0
790 rm ${STDERR_T} 1036 rm ${STDERR_T}
791 break 1037 break
792 else 1038 else
793 eend 1 1039 eend 1
794 eerror "Failed to apply patch ${i/*\//}" 1040 eerror "Failed to apply patch ${i/*\//}"
795 eerror "Please attach ${STDERR_T} to any bug you may post." 1041 eerror "Please attach ${STDERR_T} to any bug you may post."
1042 eshopts_pop
796 die "Failed to apply ${i/*\//}" 1043 die "Failed to apply ${i/*\//}"
797 fi 1044 fi
798 else 1045 else
799 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 1046 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
800 fi 1047 fi
801 done 1048 done
802 if [ ${PATCH_DEPTH} -eq 5 ]; then 1049 if [ ${PATCH_DEPTH} -eq 5 ]; then
803 eend 1 1050 eend 1
804 eerror "Please attach ${STDERR_T} to any bug you may post." 1051 eerror "Please attach ${STDERR_T} to any bug you may post."
1052 eshopts_pop
805 die "Unable to dry-run patch." 1053 die "Unable to dry-run patch."
806 fi 1054 fi
807 done 1055 done
808 done 1056 done
809 1057
811 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite, 1059 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
812 # which is why I'm not taking too much time over this. 1060 # which is why I'm not taking too much time over this.
813 local tmp 1061 local tmp
814 for i in ${UNIPATCH_DOCS}; do 1062 for i in ${UNIPATCH_DOCS}; do
815 tmp="${tmp} ${i//*\/}" 1063 tmp="${tmp} ${i//*\/}"
816 cp -f ${i} ${T}/ 1064 cp -f ${i} "${T}"/
817 done 1065 done
818 UNIPATCH_DOCS="${tmp}" 1066 UNIPATCH_DOCS="${tmp}"
819 1067
820 # clean up KPATCH_DIR's - fixes bug #53610 1068 # clean up KPATCH_DIR's - fixes bug #53610
821 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 1069 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
822 1070
823 LC_ALL="${myLC_ALL}" 1071 LC_ALL="${myLC_ALL}"
824 LANG="${myLANG}" 1072 LANG="${myLANG}"
1073 eshopts_pop
825} 1074}
826 1075
827# getfilevar accepts 2 vars as follows: 1076# getfilevar accepts 2 vars as follows:
828# getfilevar <VARIABLE> <CONFIGFILE> 1077# getfilevar <VARIABLE> <CONFIGFILE>
829# pulled from linux-info 1078# pulled from linux-info
941 return 0 1190 return 0
942} 1191}
943 1192
944headers___fix() { 1193headers___fix() {
945 # Voodoo to partially fix broken upstream headers. 1194 # Voodoo to partially fix broken upstream headers.
946 # Issues with this function should go to plasmaroo. 1195 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
947 sed -i \ 1196 sed -i \
948 -e "s/\([ "$'\t'"]\)\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/\1__\2\3\4/g;" \ 1197 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
949 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1198 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
950 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1199 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
951 -e "s/^\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/__\1\2\3/g;" \ 1200 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
952 -e "s/ inline / __inline__ /g" \ 1201 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
953 "$@" 1202 "$@"
954} 1203}
955 1204
956# common functions 1205# common functions
957#============================================================== 1206#==============================================================
958kernel-2_src_unpack() { 1207kernel-2_src_unpack() {
959 universal_unpack 1208 universal_unpack
1209 debug-print "Doing unipatch"
960 1210
961 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \ 1211 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
962 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}" 1212 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1213
1214 debug-print "Doing premake"
963 1215
964 # allow ebuilds to massage the source tree after patching but before 1216 # allow ebuilds to massage the source tree after patching but before
965 # we run misc `make` functions below 1217 # we run misc `make` functions below
966 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake 1218 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
967 1219
1220 debug-print "Doing epatch_user"
1221 epatch_user
1222
1223 debug-print "Doing unpack_set_extraversion"
1224
968 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1225 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
969 unpack_fix_docbook
970 unpack_fix_install_path 1226 unpack_fix_install_path
971 1227
1228 # Setup xmakeopts and cd into sourcetree.
1229 env_setup_xmakeopts
1230 cd "${S}"
1231
1232 # We dont need a version.h for anything other than headers
1233 # at least, I should hope we dont. If this causes problems
1234 # take out the if/fi block and inform me please.
1235 # unpack_2_6 should now be 2.6.17 safe anyways
1236 if [[ ${ETYPE} == headers ]]; then
972 kernel_is 2 4 && unpack_2_4 1237 kernel_is 2 4 && unpack_2_4
973 kernel_is 2 6 && unpack_2_6 1238 kernel_is 2 6 && unpack_2_6
1239 fi
1240
1241 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1242 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1243 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1244 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1245 fi
974} 1246}
975 1247
976kernel-2_src_compile() { 1248kernel-2_src_compile() {
977 cd "${S}" 1249 cd "${S}"
978 [[ ${ETYPE} == headers ]] && compile_headers 1250 [[ ${ETYPE} == headers ]] && compile_headers
979 [[ ${ETYPE} == sources ]] && \ 1251
980 use doc && compile_manpages 1252 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1253 echo ">>> Running deblob script ..."
1254 sh "${T}/${DEBLOB_A}" --force || \
1255 die "Deblob script failed to run!!!"
1256 fi
981} 1257}
1258
1259# if you leave it to the default src_test, it will run make to
1260# find whether test/check targets are present; since "make test"
1261# actually produces a few support files, they are installed even
1262# though the package is binchecks-restricted.
1263#
1264# Avoid this altogether by making the function moot.
1265kernel-2_src_test() { :; }
982 1266
983kernel-2_pkg_preinst() { 1267kernel-2_pkg_preinst() {
984 [[ ${ETYPE} == headers ]] && preinst_headers 1268 [[ ${ETYPE} == headers ]] && preinst_headers
985} 1269}
986 1270
989 [[ ${ETYPE} == headers ]] && install_headers 1273 [[ ${ETYPE} == headers ]] && install_headers
990 [[ ${ETYPE} == sources ]] && install_sources 1274 [[ ${ETYPE} == sources ]] && install_sources
991} 1275}
992 1276
993kernel-2_pkg_postinst() { 1277kernel-2_pkg_postinst() {
994 [[ ${ETYPE} == headers ]] && postinst_headers
995 [[ ${ETYPE} == sources ]] && postinst_sources 1278 [[ ${ETYPE} == sources ]] && postinst_sources
996} 1279}
997 1280
998kernel-2_pkg_setup() { 1281kernel-2_pkg_setup() {
1282 if kernel_is 2 4; then
1283 if [ "$( gcc-major-version )" -eq "4" ] ; then
1284 echo
1285 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1286 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1287 ewarn "newer kernel that supports gcc-4."
1288 echo
1289 ewarn "Also be aware that bugreports about gcc-4 not working"
1290 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1291 echo
1292 epause 10
1293 fi
1294 fi
1295
1296 ABI="${KERNEL_ABI}"
999 [[ ${ETYPE} == headers ]] && setup_headers 1297 [[ ${ETYPE} == headers ]] && setup_headers
1000 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1298 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
1001} 1299}
1300
1301kernel-2_pkg_postrm() {
1302 echo
1303 ewarn "Note: Even though you have successfully unmerged "
1304 ewarn "your kernel package, directories in kernel source location: "
1305 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1306 ewarn "with modified files will remain behind. By design, package managers"
1307 ewarn "will not remove these modified files and the directories they reside in."
1308 echo
1309}
1310

Legend:
Removed from v.1.162  
changed lines
  Added in v.1.258

  ViewVC Help
Powered by ViewVC 1.1.20